<template>
  <v-container>
    <v-row no-gutters class="mb-0">
      <v-col class="text-right pr-2">
        <h1>{{ article.title }}</h1>
        <div v-if="article.author">Par {{ article.author }}</div>
        <div>Publié le {{ formatedDate }}</div>
      </v-col>
      <template v-if="article.cover">
        <v-divider class="d-none d-sm-flex" vertical />
        <v-col cols="12" sm="6">
          <v-img
            :src="article.cover"
            contain
            :position="
              $vuetify.breakpoint.smAndUp ? 'top left' : 'center center'
            "
            max-height="200px"
          />
        </v-col>
      </template>
    </v-row>
    <v-divider />
    <nuxt-content :document="article" />
    <v-row>
      <v-col v-if="next" class="text-left">
        <v-btn text x-large nuxt :to="next.path">
          Article suivant :<br />
          ← {{ next.title }}
        </v-btn>
      </v-col>
      <v-spacer />
      <v-col v-if="prev" class="text-right">
        <v-btn text x-large nuxt :to="prev.path">
          Article précédent :<br />
          {{ prev.title }} →
        </v-btn>
      </v-col>
    </v-row>
  </v-container>
</template>

<script>
export default {
  async asyncData({ params, $content, error }) {
    let article
    try {
      article = await $content('blog', params.slug).fetch()
    } catch {
      error({ statusCode: 404, message: "Cet article n'existe pas" })
    }

    const [prev, next] = await $content('blog')
      .only(['title', 'path'])
      .sortBy('date')
      .surround(params.slug)
      .fetch()

    return {
      article,
      prev,
      next,
    }
  },

  computed: {
    formatedDate() {
      const date = new Date(this.article.date)
      return date.toLocaleDateString('fr-FR', {
        year: 'numeric',
        month: 'long',
        day: 'numeric',
      })
    },
  },

  head() {
    return {
      title: `${this.article.title} − Blog`,
    }
  },
}
</script>
